image.hh File Reference
`#include <mia/core/attributes.hh>`
`#include <mia/core/pixeltype.hh>`
`#include <mia/core/filter.hh>`
`#include <mia/core/msgstream.hh>`
`#include <mia/core/tools.hh>`
`#include <mia/core/type_traits.hh>`
`#include <mia/2d/vectorfield.hh>`
Include dependency graph for 2d/image.hh:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

class | C2DImage
| This is the base class for 2D images that can hold generic pixel data. More...
class | CImageComparePrinter
| a class to print out the intensity values of two images to compare them More...
class | CopyC2DImageToP2DImage
| functor to copy an image into paointer representation More...
struct | FConvert2DImageToPixeltypeO< O >
| functor to convert an image with an abitrary pixel type to single floating point pixels More...
class | T2DImage< T >
| This is the template version of a 2D image that is used for holding real data. More...

## Macros

#define | ATTR_IMAGE_KMEANS_CLASSES "kmeans"

## Typedefs

typedef T2DImage< bool > | C2DBitImage
| 2D image with binary values
typedef T2DImage< double > | C2DDImage
| 2D image with double precsion floating point values
typedef T2DImage< float > | C2DFImage
| 2D image with single precsion floating point values
typedef std::map< std::string, C2DImageSeriesGroup > | C2DImageGroupedSeries
typedef std::vector< P2DImage > | C2DImageSeries
| helper type for image series
typedef std::vector< C2DImageSeries > | C2DImageSeriesGroup
typedef T2DImage< int8_t > | C2DSBImage
| 2D image with signed 8 bit integer values
typedef T2DImage< int32_t > | C2DSIImage
| 2D image with signed 32 bit integer values
typedef T2DImage< int64_t > | C2DSLImage
| 2D image with signed 64 bit integer values
typedef T2DImage< int16_t > | C2DSSImage
| 2D image with signed 16 bit integer values
typedef T2DImage< uint8_t > | C2DUBImage
| 2D image with unsigned 8 bit integer values
typedef T2DImage< uint32_t > | C2DUIImage
| 2D image with unsigned 32 bit integer values
typedef T2DImage< uint64_t > | C2DULImage
| 2D image with unsigned 64 bit integer values
typedef T2DImage< uint16_t > | C2DUSImage
| 2D image with unsigned 16 bit integer values
typedef FConvert2DImageToPixeltypeO< float > | FCopy2DImageToFloatRepn
| short name for 2DImage to float pixel repn copy functor
typedef C2DImage::Pointer | P2DImage
| Shared pointer representation of the 2D Image.
typedef std::shared_ptr< C2DImageSeries > | P2DImageSeries

## Functions

EXPORT_2D C2DFVectorfield | get_gradient (const C2DImage &image)
bool | operator!= (const C2DImage &a, const C2DImage &b)
EXPORT_2D bool | operator== (const C2DImage &a, const C2DImage &b)

## Macro Definition Documentation

## ATTR_IMAGE_KMEANS_CLASSES

#define ATTR_IMAGE_KMEANS_CLASSES "kmeans"

Definition at line 35 of file 2d/image.hh.

## Typedef Documentation

## C2DBitImage

typedef T2DImage<bool> C2DBitImage

2D image with binary values

Definition at line 442 of file 2d/image.hh.

## C2DDImage

typedef T2DImage<double> C2DDImage

2D image with double precsion floating point values

Definition at line 472 of file 2d/image.hh.

## C2DFImage

typedef T2DImage<float> C2DFImage

2D image with single precsion floating point values

Definition at line 469 of file 2d/image.hh.

## C2DImageGroupedSeries

typedef std::map<std::string, C2DImageSeriesGroup> C2DImageGroupedSeries

Definition at line 128 of file 2d/image.hh.

## C2DImageSeries

typedef std::vector<P2DImage> C2DImageSeries

helper type for image series

Definition at line 123 of file 2d/image.hh.

## C2DImageSeriesGroup

typedef std::vector<C2DImageSeries> C2DImageSeriesGroup

Definition at line 127 of file 2d/image.hh.

## C2DSBImage

typedef T2DImage<int8_t> C2DSBImage

2D image with signed 8 bit integer values

Definition at line 445 of file 2d/image.hh.

## C2DSIImage

typedef T2DImage<int32_t> C2DSIImage

2D image with signed 32 bit integer values

Definition at line 457 of file 2d/image.hh.

## C2DSLImage

typedef T2DImage<int64_t> C2DSLImage

2D image with signed 64 bit integer values

Definition at line 463 of file 2d/image.hh.

## C2DSSImage

typedef T2DImage<int16_t> C2DSSImage

2D image with signed 16 bit integer values

Definition at line 451 of file 2d/image.hh.

## C2DUBImage

typedef T2DImage<uint8_t> C2DUBImage

2D image with unsigned 8 bit integer values

Definition at line 448 of file 2d/image.hh.

## C2DUIImage

typedef T2DImage<uint32_t> C2DUIImage

2D image with unsigned 32 bit integer values

Definition at line 460 of file 2d/image.hh.

## C2DULImage

typedef T2DImage<uint64_t> C2DULImage

2D image with unsigned 64 bit integer values

Definition at line 466 of file 2d/image.hh.

## C2DUSImage

typedef T2DImage<uint16_t> C2DUSImage

2D image with unsigned 16 bit integer values

Definition at line 454 of file 2d/image.hh.

## FCopy2DImageToFloatRepn

typedef FConvert2DImageToPixeltypeO<float> FCopy2DImageToFloatRepn

short name for 2DImage to float pixel repn copy functor

Since copy-conversion to a floating pixel type image is used often we provide here a typedef for the functor.

Definition at line 547 of file 2d/image.hh.

## P2DImage

typedef C2DImage::Pointer P2DImage

Shared pointer representation of the 2D Image.

Definition at line 120 of file 2d/image.hh.

## P2DImageSeries

typedef std::shared_ptr<C2DImageSeries> P2DImageSeries

Definition at line 125 of file 2d/image.hh.

## Function Documentation

## get_gradient()

EXPORT_2D C2DFVectorfield get_gradient | ( | const C2DImage & | image | ) |

Evaluate the gradient of an image using finite differences

Remarks
  should be changed to use interpolator

References EXPORT_2D.

Referenced by T3DImage< bool >::get_gradient().

## operator!=()

bool operator!= | ( | const C2DImage & | a,
|  | const C2DImage & | b )

inline

Evaluate if two images are not equal in size, pixel type or all its pixels. Meta data is not considered, nor is the pixel size.

Definition at line 413 of file 2d/image.hh.

## operator==()

EXPORT_2D bool operator== | ( | const C2DImage & | a,
|  | const C2DImage & | b )

Evaluate if two images are equal in size, pixel type and all its pixels. Meta data is not considered, nor is the pixel size

Parameters

  a |
  b |

Returns
  result of comparison

Remarks
  pixel size should probably also compared
  who calls this function anyway?

References EXPORT_2D.